# Batching demo

This demo demonstrates the usage of the new `sf2d_batch` related functions.
Batching is a way to greatly increase performance if you are drawing the same texture in multiple places on screen.  (Think tilemaps). A good explanation of this technique can be read about at the following [link](https://gamedev.stackexchange.com/questions/32910/what-is-the-technical-definition-of-sprite-batching)

The code for this was adapted from a citro3d tutorial which was written by WinterMute.


## Demo code
The demo shows a bunch of balls being drawn at various locations, you can increase or decrease the number of balls using the up or down buttons.

You can also switch between batched drawing and using the `sf2d_draw_texture_part` function to see the differences in performance. 

### Performance
Performance was measured when compiled as a cia rendering 1600 sprites running on a small new nintendo 3ds.
The things measured are the fps as reported by `sf2d_get_fps` (may not be accurate) and the CPU and GPU processing times via `C3D_GetProcessingTime` and `C3D_GetDrawingTime` respectively.


| Environment      | FPS | CPU      | GPU  |
|------------------|-----|----------|------|
| Batching         | 30  | 15%      | 93%  |
| Nonbatched       | 20  | 150-200% | 100% |


## Credits
[WinterMute](https://github.com/WinterMute): As this sample was adapted from [3ds-examples](https://github.com/devkitPro/3ds-examples/blob/master/graphics/gpu/gpusprites/source/main.c) as well as for the ballsprites.png image file

The ballsprites_img.c file was generated by GIMP.
